#include "RooGaussian.h"
#include "RooRealVar.h"
#include "RooWorkspace.h"
#include "RooAbsPdf.h"
#include "TClass.h"
#include "child.C"


void demo(){

    // set up workspace
    RooWorkspace* w = new RooWorkspace("w","w");
    RooRealVar* x = new RooRealVar("x","x",0,0,1);
    RooRealVar* s = new RooRealVar("s","s",0,0,1);
    RooRealVar* m = new RooRealVar("m","m",0,0,1);
    RooGaussian* g = new RooGaussian("gaus","gaus",*x,*m,*s);
    child* childOne = new child("child");
    child* childTwo = new child("child");
    w->import(*x);
    w->import(*s);
    w->import(*m);

    cout<<"import standard PDF (OK)\n";
    w->import(*g);

    cout<<"import child PDF with a static cast (OK)\n";
    w->import(*(TObject*)(childOne));
    cout<<"but object in workspace == zero (Bad): "<<w->obj("child")<<endl;

    cout<<"import child PDF without dynamic_cast (Crash!)\n";
    w->import(*childOne);

    cout<<"DONE"<<endl;
}

int main(){ demo(); return 1;}
